-- disable for rom hacks and game modes
strawberriesExist = true
notGameMode = true
for i, mod in pairs(gActiveMods) do
    if mod.enabled then
        if (mod.incompatible and mod.incompatible:find("romhack") or mod.category and mod.category == "romhack") then
            strawberriesExist = false
        elseif (mod.incompatible and mod.incompatible:find("gamemode") or mod.category and mod.category == "gamemode") then
            strawberriesExist = false
            notGameMode = false
            break
        end
    end
end

E_MODEL_STRAWBERRY = smlua_model_util_get_id("strawberry_geo")
E_MODEL_STRAWBERRY_BLUE = smlua_model_util_get_id("strawberry_blue_geo") -- todo:update
E_MODEL_SPLASH = smlua_model_util_get_id("splash_geo")
E_MODEL_STRAWBERRY_GOLD = smlua_model_util_get_id("strawberry_gold_geo")
E_MODEL_STRAWBERRY_GOLD_BLUE = smlua_model_util_get_id("strawberry_gold_blue_geo")
E_MODEL_STRAWBERRY_MOON = smlua_model_util_get_id("strawberry_moon_geo")
E_MODEL_STRAWBERRY_MOON_BLUE = smlua_model_util_get_id("strawberry_moon_blue_geo")
E_MODEL_STRAWBERRY_SWITCH = smlua_model_util_get_id("berrySwitch_geo")
E_MODEL_STRAWBERRY_SWITCH_BASE = smlua_model_util_get_id("berrySwitchBase_geo")
local TEX_STRAWBERRY = get_texture_info("strawberry_hud")
local TEX_STRAWBERRY_GOLD = get_texture_info("strawberry_gold_hud")
local TEX_STRAWBERRY_MOON = get_texture_info("strawberry_moon_hud")

local STRAWB_GET_TIME = 90
local delayStrawberryUpdate = 0
syncTimer = 0
local prevDispHudTimer = false
local dispBlueCoinTimer = 0
local gotStrawberryList = {}
--- x, y, z, area, id
local strawberry_pos = {}
strawberry_pos[1] = {
    [LEVEL_BOB] = {2900, 8261, -4717, 1, 1},
    [LEVEL_WF] = {0, 6910, 0, 1, 2},
    [LEVEL_JRB] = {7979, 4000, 2672, 1, 3},
    [LEVEL_CCM] = {-4948, 2844, 6100, 2, 4},
    [LEVEL_BBH] = {0, -1594, 200, 1, 5},
    [LEVEL_HMC] = {389, 5178, 4309, 1, 6},
    [LEVEL_LLL] = {2633, 5170, 417, 2, 7},
    [LEVEL_SSL] = {2496, -570, -420, 3, 8},
    [LEVEL_DDD] = {-3285, 1065, 0, 2, 9},
    [LEVEL_SL] = {-3869, 4000, -400, 1, 10},
    [LEVEL_WDW] = {4000, 7279, 3239, 1, 11},
    [LEVEL_TTM] = {7297, -3789, 1179, 1, 12},
    [LEVEL_THI] = {4323, -2145, -5303, 1, 13},
    [LEVEL_TTC] = {0, 7600, 0, 1, 14},
    [LEVEL_RR] = {-4427, 2000, -5158, 1, 15},
    [LEVEL_BITDW] = {-4628, -1171, -355, 1, 16},
    [LEVEL_BITFS] = {2620, 3110, 613, 1, 17},
    [LEVEL_BITS] = {-8074, -1000, -6814, 1, 18},
    [LEVEL_PSS] = {-6467, -548, 7717, 1, 19},
    [LEVEL_COTMC] = {0, 654, 4251, 1, 20},
    [LEVEL_TOTWC] = {-4100, 4100, 4100, 1, 21},
    [LEVEL_VCUTM] = {4731, -3726, 4026, 1, 22},
    [LEVEL_WMOTR] = {0, 6500, 0, 1, 23},
    [LEVEL_CASTLE_GROUNDS] = {0, 9500, -4025, 1, 24},
    [LEVEL_CASTLE_COURTYARD] = {0, 3188, 112, 1, 25},
}
local strawberry_hints = {}
strawberry_hints[1] = {
    "BOB: Reach Above The Summit",
    "WF: Over Whomp's Fortress",
    "JRB: Overlooking The Ship",
    "CCM: Secret Path On Snow Slide",
    "BBH: Climb Big Boo's Merry-Go-Round",
    "HMC: Climb Beyond The Cave Pole",
    "LLL: Top Of The Volcano",
    "SSL: Eyerok's Tomb",
    "DDD: Passage To Bowser's Sub",
    "SL: Leap From Snowman's Head",
    "WDW: Launch Out Of The World",
    "TTM: Blast Below The Lonely Mushroom",
    "THI: Under The Windy Bridge",
    "TTC: Tip-Top Clock",
    "RR: Beneath The Big House",
    "BITDW: Under The Dark Spire",
    "BITFS: Climb The Fire Pillars",
    "BITS: Long Leap In The Sky",
    "PSS: Secret Spot In Secret Slide",
    "COTMC: Hidden Behind The Waterfall",
    "TOTWC: Top Of The Blue Tower",
    "VCUTM: Climb Around The Moat",
    "WMOTR: Wing Mario Way Over The Rainbow",
    "CASTLE: The Castle's Summit",
    "CASTLE: A Not \"ReaL\" Hidden Spot",
}
local strawberry_switch = {}
strawberry_switch[1] = {} -- no switches for red berries
--- x, y, z, area, id, act, radar tag
strawberry_pos[2] = {
    [LEVEL_BOB] = {-547, 4800, -1182, 1, 1},
    [LEVEL_WF] = {-920, 5640, -2894, 1, 2, 1},
    [LEVEL_JRB] = {4716, 3200, 3167, 1, 3, 1},
    [LEVEL_CCM] = {2404, -4915, 3492, 1, 4, nil, true},
    -- [LEVEL_CCM] = {650, -5524, 2071, 1, 4},
    [LEVEL_BBH] = {4091, 3360, 6033, 1, 5},
    [LEVEL_HMC] = {-3594, 550, 3201, 1, 6, nil, true},
    [LEVEL_LLL] = {0, 6400, -2400, 2, 7},
    [LEVEL_SSL] = {-3919, 3000, 4069, 1, 8},
    [LEVEL_DDD] = {6607, 3210, -3519, 2, 9, nil, true},
    [LEVEL_SL] = {0, 6500, 0, 1, 10, nil, true},
    [LEVEL_WDW] = {209, 5900, -80, 1, 11},
    [LEVEL_TTM] = {3900, -3000, -1700, 1, 12, nil, true},
    [LEVEL_THI] = {5500, - 2300, -26, 1, 13, nil, true},
    [LEVEL_TTC] = {-947, 6250, -856, 1, 14, nil, true},
    [LEVEL_RR] = {5081, 2600, 4059, 1, 15},
    [LEVEL_BITDW] = {6450, 2950, -7, 1, 16, nil, true},
    [LEVEL_BOWSER_2] = {0, -500, 0, 1, 17, nil, true}, -- too easy?
    [LEVEL_BITS] = {351, 6550, -6030, 1, 18, nil, true},
    [LEVEL_PSS] = {-6337, -5317, 404, 1, 19, nil, true},
    [LEVEL_COTMC] = {-12, 3000, -6145, 1, 20},
    [LEVEL_VCUTM] = {-6504, 6348, 6504, 1, 21},
    [LEVEL_WMOTR] = {2716, 3150, -3067, 1, 22},
    [LEVEL_CASTLE_GROUNDS] = {0, 7000, -333, 1, 23},
    [LEVEL_CASTLE] = {-194, 5600, 6924, 2, 24},
}
strawberry_hints[2] = {
    "BOB: Go Long Off The Summit",
    "WF: High Jump From The King",
    "JRB: Trick Jump Over The Bay",
    "CCM: Under The Cabin",
    "BBH: Highest In The Haunt",
    "HMC: Go Into The Light",
    "LLL: Above The Volcano Top",
    "SSL: Wind Whisperer",
    "DDD: Beyond The Docks",
    "SL: A Head Of Time",
    "WDW: Overtop Of The Town",
    "TTM: Wall, Wall Mountain",
    "THI: Huge Leap Inside The Island",
    "TTC: Tick Tock!",
    "RR: Somewhere Under The Rainbow",
    "BITDW: Dashing Through Darkness",
    "BITFS: Under The Fiery Arena",
    "BITS: Before The Finale",
    "PSS: Slip Under The Slide",
    "COTMC: Climb The Cavern Waterfall",
    "VCUTM: Corner Of The Moat",
    "WMOTR: Into The Stormcloud",
    "CASTLE: Leap From The Castle Top",
    "CASTLE: Atop The Old Clock",
}
-- key is the strawberry's id, not the level
-- x, y, z, timer
strawberry_switch[2] = {
    [10] = {5494, 1024, 0, 10 * 30}, -- 10 seconds
    [14] = {900, -4822, 0, 20 * 30}, -- 20 seconds
    [16] = {-7100, -3153, 4300, 20 * 30}, -- 20 seconds
}
--- x, y, z, area, id, act, radar tag
strawberry_pos[3] = {
    [LEVEL_BOB] = {1809, 900, 429, 1, 1, nil, true},
    [LEVEL_WF] = {3500, 1075, -2533, 1, 2, nil, true},
    [LEVEL_JRB] = {-1829, 5500, 1548, 1, 3},
    [LEVEL_CCM] = {-5680, 7544, 8017, 2, 4, nil, true},
    [LEVEL_BBH] = {3687, -300, -1505, 1, 5, nil, true},
    [LEVEL_HMC] = {3822, -300, 2448, 1, 6, nil, true},
    [LEVEL_LLL] = {2800, 2600, 2368, 1, 7},
    [LEVEL_SSL] = {0, 5500, 256, 2, 8, nil, true},
    [LEVEL_DDD] = {1032, -3900, -3939, 2, 9, nil, true},
    [LEVEL_SL] = {-3869, 4300, -400, 1, 10, nil, true},
    [LEVEL_WDW] = {-2483, -1046, -3314, 1, 11, nil, true},
    [LEVEL_TTM] = {8191, -7776, -23, 3, 12, nil, true},
    [LEVEL_THI] = {-4673, -3068, 6227, 1, 13, nil, true},
    [LEVEL_TTC] = {2200, -3742, 800, 1, 14, nil, true},
    [LEVEL_RR] = {3752, 5800, -2363, 1, 15, nil, true},
    [LEVEL_BITDW] = {-5124, 1000, -2400, 1, 16, nil, true},
    [LEVEL_BITFS] = {6747, 3000, 68, 1, 17},
    [LEVEL_BITS] = {351, 7000, -6030, 1, 18, nil, true},
    [LEVEL_PSS] = {380, -1200, -5028, 1, 19, nil, true},
    [LEVEL_COTMC] = {-12, 4000, -6145, 1, 20, nil, true},
    [LEVEL_VCUTM] = {4621, 6164, 5496, 1, 21},
    [LEVEL_WMOTR] = {3996, -1600, 5477, 1, 22},
}
strawberry_hints[3] = {
    "BOB: 10 Second Clip",
    "WF: Bowels Of The Fortress",
    "JRB: Careful Climbing",
    "CCM: Climb In The Cold Corner",
    "BBH: Buried By The House",
    "HMC: Spelunk In The Hazy Cave",
    "LLL: Jump Over The Fiery Land",
    "SSL: Scale The Pyramid",
    "DDD: Clip And Clip Again",
    "SL: Another Leap From Snowman's Head",
    "WDW: Wrong Tunnel Entrance",
    "TTM: Outsmart The Slide's Trap",
    "THI: Chuckya's Island Tour",
    "TTC: Time For Another Clip",
    "RR: Rainbow Ride Race",
    "BITDW: Thingamajig In The Darkness",
    "BITFS: You Can Stand Here!?",
    "BITS: Sky Speedrun",
    "PSS: Reach The Pillar",
    "COTMC: Waterfall Wall Kicks",
    "VCUTM: Corner Of The Moat, Again?",
    "WMOTR: Coinful Capless Cannonless",
}
-- key is the strawberry's id, not the level
-- x, y, z, timer
strawberry_switch[3] = {
    [1] = {-4900, 0, 4900, 10 * 30}, -- 10 seconds
    [7] = {1088, 154, 6527, 10 * 30}, -- 10 seconds
    [8] = {670, 0, 2900, 10 * 30}, -- 10 seconds
    [9] = {6730, -4087, -3899, 15 * 30}, -- 15 seconds
    [10] = {5494, 1024, -500, 12 * 30}, -- 12 seconds
    [11] = {-3680, 3584, -3680, 10 * 30}, -- 10 seconds
    [15] = {1970, -1833, 2071, 15 * 30}, -- 15 seconds
    [16] = {6800, 2867, 400, 10 * 30}, -- 10 seconds
    [18] = {-7314, -4812, 4, 25 * 30}, -- 25 seconds
    [19] = {-7387, -4587, 4349, 20 * 30}, -- 20 seconds
    [22] = {554, 1669, -786, 0, -6582} -- 0 spawns a sign instead; 5th field is the yaw
}

local TOTAL_STRAWBERRIES = #strawberry_hints[1]
local TOTAL_STRAWBERRIES_GOLD = #strawberry_hints[2]
local TOTAL_STRAWBERRIES_MOON = #strawberry_hints[3]

-- load strawberry progress
gGlobalSyncTable.strawbData = 0
gGlobalSyncTable.goldStrawbData = 0
gGlobalSyncTable.moonStrawbData = 0
local prevSaveFile = get_current_save_file_num() - 1
if save_file_get_using_backup_slot() then
    prevSaveFile = prevSaveFile + 4
end
if strawberriesExist then
    -- red
    for i = 1, TOTAL_STRAWBERRIES do
        if mod_storage_load_bool("strawb_" .. prevSaveFile .. "_" .. i) then
            gGlobalSyncTable.strawbData = gGlobalSyncTable.strawbData | (1 << (i - 1))
        end
    end
    if DEBUG_ENABLED or gGlobalSyncTable.strawbData >= ((1 << TOTAL_STRAWBERRIES) - 1) then
        gGlobalSyncTable.redBerryDone = true
    end

    -- gold
    for i = 1, TOTAL_STRAWBERRIES_GOLD do
        if mod_storage_load_bool("strawb_" .. prevSaveFile .. "_" .. i .."_1") then
            gGlobalSyncTable.goldStrawbData = gGlobalSyncTable.goldStrawbData | (1 << (i - 1))
        end
    end
    if DEBUG_ENABLED or gGlobalSyncTable.goldStrawbData >= ((1 << TOTAL_STRAWBERRIES_GOLD) - 1) then
        gGlobalSyncTable.goldBerryDone = true
    end

    -- moon
    for i = 1, TOTAL_STRAWBERRIES_MOON do
        if mod_storage_load_bool("strawb_" .. prevSaveFile .. "_" .. i .."_2") then
            gGlobalSyncTable.moonStrawbData = gGlobalSyncTable.moonStrawbData | (1 << (i - 1))
        end
    end
    if DEBUG_ENABLED or gGlobalSyncTable.moonStrawbData >= ((1 << TOTAL_STRAWBERRIES_MOON) - 1) then
        gGlobalSyncTable.moonBerryDone = true
    end
end

-- spawn strawberries and also update progress
function handle_strawberry_spawn()
    if (not strawberriesExist) or obj_get_first_with_behavior_id(id_bhvActSelector) then return end
    ---@type NetworkPlayer
    local np = gNetworkPlayers[0]

    -- reload strawberry progress
    local saveFile = get_current_save_file_num() - 1
    if save_file_get_using_backup_slot() then
        saveFile = saveFile + 4
    end

    if network_is_server() and np.currActNum ~= 99 then
        if prevSaveFile ~= saveFile then
            prevSaveFile = saveFile
            gGlobalSyncTable.strawbData = 0
            for i = 1, TOTAL_STRAWBERRIES do
                if mod_storage_load_bool("strawb_" .. saveFile .. "_" .. i) then
                    gGlobalSyncTable.strawbData = gGlobalSyncTable.strawbData | (1 << (i - 1))
                end
            end
        elseif save_file_get_flags() & SAVE_FLAG_FILE_EXISTS == 0 then
            --djui_chat_message_create("ERASED")
            save_file_set_flags(SAVE_FLAG_FILE_EXISTS)
            erase_strawberry_progress()
        end
    end

    syncTimer = 5
    if dispBlueCoinTimer ~= 0 and not prevDispHudTimer then
        dispBlueCoinTimer = 0
        hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) & ~HUD_DISPLAY_FLAGS_TIMER)
    end

    if invalid_strawberry_options() or np.currActNum == 99 then return end

    -- spawn red strawberry
    local pos = strawberry_pos[1][np.currLevelNum]
    if pos and np.currAreaIndex == pos[4] and (pos[6] == nil or np.currActNum == pos[6]) then
        handle_strawberry_spawn(pos, 0)
    end

    -- spawn gold strawberry
    ---@type NetworkPlayer
    pos = strawberry_pos[2][np.currLevelNum]
    if pos and np.currAreaIndex == pos[4] and (pos[6] == nil or np.currActNum == pos[6]) and gGlobalSyncTable.redBerryDone then
        handle_strawberry_spawn(pos, 1)
    end

    -- spawn moon berry
    ---@type NetworkPlayer
    pos = strawberry_pos[3][np.currLevelNum]
    if pos and np.currAreaIndex == pos[4] and (pos[6] == nil or np.currActNum == pos[6]) and gGlobalSyncTable.goldBerryDone then
        handle_strawberry_spawn(pos, 2)
    end
end

hook_event(HOOK_ON_SYNC_VALID, handle_strawberry_spawn)

-- check if a strawberry of a given id and type is collected
function is_berry_collected(id, type)
    local collectedData = gGlobalSyncTable.strawbData
    if type == 1 then
        collectedData = gGlobalSyncTable.goldStrawbData
    elseif type == 2 then
        collectedData = gGlobalSyncTable.moonStrawbData
    end
    return collectedData & (1 << (id - 1)) ~= 0
end

-- check if our options are invalid for strawberries
-- true if we have neutral jump, infinite stamina, or super dash on, or max dashes greater than 1
function invalid_strawberry_options()
    return gGlobalSyncTable.allowNeutral or gGlobalSyncTable.infStamina or gGlobalSyncTable.superDash or gGlobalSyncTable.dashCount > 1
end

-- handles strawberry spawning for both red and gold.
function handle_strawberry_spawn(pos, type)
    -- always spawn switch as a non-sync object
    local switchExists = false
    if pos[5] and strawberry_switch[type+1] and strawberry_switch[type+1][pos[5]] then
        switchExists = true
        local switchPos = strawberry_switch[type+1][pos[5]]
        spawn_non_sync_object(id_bhvMistCircParticleSpawner, E_MODEL_NONE, switchPos[1], switchPos[2] + 40, switchPos[3], nil)
        if switchPos[4] ~= 0 then
            spawn_non_sync_object(id_bhvStrawberrySwitch, E_MODEL_STRAWBERRY_SWITCH, switchPos[1], switchPos[2] + 32.5, switchPos[3], function(o)
                o.oBehParams = switchPos[4]
                o.oBehParams2ndByte = type
            end)
        else
            smlua_text_utils_dialog_replace(DIALOG_033, 1, 5, 30, 200,
                "This final moon berry will\n"..
                "be a little different.\n"..
                "You must COLLECT all 8\n"..
                "Red Coins without the\n"..
                "wing cap or cannons!\n"..
                "Also, the strawberry will\n"..
                "disappear if ANYONE\n"..
                "breaks the rules, so be\n"..
                "careful! I believe you\n"..
                "can do it!")
            spawn_non_sync_object(id_bhvMessagePanel, E_MODEL_WOODEN_SIGNPOST, switchPos[1], switchPos[2], switchPos[3], function(o)
                o.oFaceAngleYaw = switchPos[5]
                o.oMoveAngleYaw = switchPos[5]
                o.oFaceAnglePitch = 0
                o.oFaceAngleRoll = 0
                o.oBehParams2ndByte = DIALOG_033 -- "Ciao! You've reached..."
            end)
        end
    end
    
    -- check if the strawberry already exists
    local strawberry = obj_get_first_with_behavior_id_and_field_s32(id_bhvStrawberry, 0x2F, type) -- 0x2F is "oBehParams2ndByte"
    if strawberry then return end

    -- check if we're the lowest network player here
    local np0 = gNetworkPlayers[0]
    if np0.globalIndex ~= 0 then
        for i=1,MAX_PLAYERS-1 do
            local np = gNetworkPlayers[i]
            if np.currLevelNum == np0.currLevelNum and np0.currAreaIndex == np.currAreaIndex and np0.currActNum == np.currActNum
            and np.currLevelSyncValid and np.currLevelAreaSeqId
            and np.globalIndex < np0.globalIndex then
                break
            end
        end
    end

    -- spawn strawberry, if all conditions are met
    if not switchExists then
        spawn_sync_object(id_bhvMistCircParticleSpawner, E_MODEL_NONE, pos[1], pos[2]-40, pos[3], nil)
    end
    local model = E_MODEL_STRAWBERRY
    if type == 1 then
        model = E_MODEL_STRAWBERRY_GOLD
        if is_berry_collected(pos[5], type) then -- collected
            model = E_MODEL_STRAWBERRY_GOLD_BLUE
        end
    elseif type == 2 then
        model = E_MODEL_STRAWBERRY_MOON
        if is_berry_collected(pos[5], type) then -- collected
            model = E_MODEL_STRAWBERRY_MOON_BLUE
        end
    elseif is_berry_collected(pos[5], type) then -- collected
        model = E_MODEL_STRAWBERRY_BLUE
    end
    spawn_sync_object(id_bhvStrawberry, model, pos[1], pos[2], pos[3], function(o)
        o.oBehParams = pos[5]
        o.oBehParams2ndByte = type
    end)
end

-- erases strawberry progress. Also used in debug mode, which also erases unlocked status
function erase_strawberry_progress(unlock)
    local saveFile = get_current_save_file_num() - 1
    if save_file_get_using_backup_slot() then
        saveFile = saveFile + 4
    end

    gGlobalSyncTable.strawbData = 0
    for i = 1, TOTAL_STRAWBERRIES do
        mod_storage_remove("strawb_" .. saveFile .. "_" .. i)
    end
    gGlobalSyncTable.goldStrawbData = 0
    for i = 1, TOTAL_STRAWBERRIES_GOLD do
        mod_storage_remove("strawb_" .. saveFile .. "_" .. i .. "_1")
    end
    gGlobalSyncTable.moonStrawbData = 0
    for i = 1, TOTAL_STRAWBERRIES_MOON do
        mod_storage_remove("strawb_" .. saveFile .. "_" .. i .. "_2")
    end

    --[[if unlock then
        mod_storage_remove("redBerryDone")
        gGlobalSyncTable.redBerryDone = false
        gGlobalSyncTable.dashCount = 1
    end]]
end

usedWingCapOrCannon = false
function check_use_wing_cap_or_cannon()
    local m = gMarioStates[0]
    if m.action == ACT_IN_CANNON or m.flags & MARIO_WING_CAP ~= 0 then
        usedWingCapOrCannon = true
    end
end
hook_event(HOOK_UPDATE, check_use_wing_cap_or_cannon)

-- strawberry object, similar to a star
function strawberry_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oFaceAnglePitch, o.oFaceAngleYaw, o.oFaceAngleRoll = 0, 0, 0

    local hitbox             = get_temp_object_hitbox()
    hitbox.interactType      = INTERACT_WATER_RING
    hitbox.downOffset        = 0
    hitbox.damageOrCoinValue = 0
    hitbox.health            = 0
    hitbox.numLootCoins      = 0
    hitbox.radius            = 80
    hitbox.height            = 50
    hitbox.hurtboxRadius     = 0
    hitbox.hurtboxHeight     = 0
    obj_set_hitbox(o, hitbox)

    local switchData = (strawberry_switch[o.oBehParams2ndByte+1] and strawberry_switch[o.oBehParams2ndByte+1][o.oBehParams])
    if switchData then
        cur_obj_disable_rendering_and_become_intangible(o)
    end

    network_init_object(o, false, { "oBehParams", "oBehParams2ndByte", "activeFlags", "oTimer", "oAction" })
end

function strawberry_loop(o)
    o.oFaceAngleYaw = o.oFaceAngleYaw + 0x800;
    cur_obj_unhide()
    local switchData = (strawberry_switch[o.oBehParams2ndByte+1] and strawberry_switch[o.oBehParams2ndByte+1][o.oBehParams])

    if o.oAction == 1 then
        cur_obj_enable_rendering()
        o.oIntangibleTimer = -1
        if o.oTimer >= STRAWB_GET_TIME then
            cur_obj_change_action(2)
            local m = nearest_mario_state_to_object(o)
            if m == nil or m.playerIndex ~= 0 then return end
            network_send_object(o, true)
        end
    elseif o.oAction == 2 then
        cur_obj_disable_rendering_and_become_intangible(o)
    elseif (o.oBehParams2ndByte ~= 0 and usedWingCapOrCannon) or invalid_strawberry_options() then
        if o.oIntangibleTimer ~= -1 then
            spawn_mist_particles()
            if not is_berry_collected(o.oBehParams, o.oBehParams2ndByte) then
                djui_chat_message_create("You've failed the strawberry guidelines.")
            end
            cur_obj_disable_rendering_and_become_intangible(o)
            o.oIntangibleTimer = -1
        end
        o.oSubAction = 1
        -- delete for red coin challenge (since red coins sync)
        if switchData and switchData[5] then
            obj_mark_for_deletion(o)
            network_send_object(o, true)
        end
    elseif o.oSubAction ~= 1 then
        if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
            local m = nearest_mario_state_to_object(o)
            if m == nil or m.playerIndex ~= 0 then return end

            local newStrawb = false
            if not is_berry_collected(o.oBehParams, o.oBehParams2ndByte) then
                if o.oBehParams2ndByte == 0 then
                    delayStrawberryUpdate = STRAWB_GET_TIME - 22
                else
                    delayStrawberryUpdate = 15
                end
                newStrawb = true
            end

            -- check switch for time
            if switchData and switchData[5] == nil then
                local strawbSwitch = obj_get_first_with_behavior_id_and_field_s32(id_bhvStrawberrySwitch, 0x2F, o.oBehParams2ndByte)
                if strawbSwitch then
                    local seconds = strawbSwitch.oTimer // 30
                    local miliseconds = math.floor(strawbSwitch.oTimer / 30 % 1 * 100)
                    djui_chat_message_create(string.format("Time: %d\"%02d", seconds, miliseconds))
                end
            end

            set_mario_action(m, ACT_STRAWBERRY_GET, o.oBehParams2ndByte)
            m.usedObj = o
            cur_obj_change_action(1)
            o.oTimer = 0
            network_send_include_self(true, {
                id = PACKET_STRAWB_GET,
                strawb = o.oBehParams,
                strawbType = o.oBehParams2ndByte,
                newStrawb = newStrawb,
                from = network_global_index_from_local(0),
            })
            network_send_object(o, true)
        elseif switchData then -- check switch
            if switchData[5] == nil then
                local strawbSwitch = obj_get_first_with_behavior_id_and_field_s32(id_bhvStrawberrySwitch, 0x2F, o.oBehParams2ndByte)
                if strawbSwitch and strawbSwitch.oAction ~= BLUE_COIN_SWITCH_ACT_TICKING then
                    cur_obj_disable_rendering_and_become_intangible(o)
                    -- if we're near the switch, render
                    if dispBlueCoinTimer == o.oBehParams2ndByte then
                        cur_obj_enable_rendering()
                    end
                else
                    cur_obj_enable_rendering_and_become_tangible(o)
                    o.oIntangibleTimer = 0
                    if strawbSwitch then
                        if o.oBehParams2ndByte == 2 then
                            -- spawn new gate for moon berry in bob
                            if o.oBehParams == 1 and not obj_get_first_with_behavior_id(id_bhvChainChompGate) then
                                djui_chat_message_create("You can't break the gate open for this berry.")
                                spawn_non_sync_object(id_bhvChainChompGate, E_MODEL_BOB_CHAIN_CHOMP_GATE, 1456, 768, 446, function(gate)
                                    gate.oFaceAngleYaw = -6190
                                    gate.oFaceAnglePitch, gate.oFaceAngleRoll = 0, 0
                                    local chomp = obj_get_nearest_object_with_behavior_id(gate, id_bhvChainChomp)
                                    if chomp then
                                        chomp.oChainChompHitGate = 0
                                        chomp.oChainChompReleaseStatus = CHAIN_CHOMP_RELEASED_END_CUTSCENE
                                    end
                                end)
                            elseif o.oBehParams == 8 then -- move the elevator for moon berry in ssl
                                local elevator = obj_get_first_with_behavior_id(id_bhvPyramidElevator)
                                if elevator and elevator.oAction == PYRAMID_ELEVATOR_IDLE then
                                    elevator.oAction = PYRAMID_ELEVATOR_AT_BOTTOM
                                    network_send_object(elevator, true)
                                end
                            end
                        end

                        if strawbSwitch.oTimer > strawbSwitch.oBehParams - 40 then
                            cur_obj_wait_then_blink(0, 20)
                        end
                    end
                end
            else -- wmotr special case
                local redCoin = obj_get_first_with_behavior_id(id_bhvRedCoin)
                if redCoin then
                    cur_obj_disable_rendering_and_become_intangible(o)
                else
                    cur_obj_enable_rendering_and_become_tangible(o)
                    o.oIntangibleTimer = 0
                end
            end
        else
            cur_obj_enable_rendering_and_become_tangible(o)
        end
    end

    o.oInteractStatus = 0
end

id_bhvStrawberry = hook_behavior(nil, OBJ_LIST_LEVEL, true, strawberry_init, strawberry_loop, "bhvStrawberry")

-- "splash" effect (the spiky circle used during the strawberry grab animation)
function splash_effect_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oFaceAnglePitch, o.oFaceAngleYaw, o.oFaceAngleRoll = 0, 0, 0
    obj_set_billboard(o)
    cur_obj_scale(10)
end

function splash_effect_loop(o)
    local index = network_local_index_from_global(o.globalPlayerIndex) or 255
    if index == 255 then
        obj_mark_for_deletion(o)
        return
    end
    local m = gMarioStates[index]
    if (is_player_active(m) == 0 or m.action ~= ACT_STRAWBERRY_GET) and o.oTimer > 30 then
        obj_mark_for_deletion(o)
        return
    end
    o.oPosX = m.pos.x
    o.oPosY = m.pos.y + 80
    o.oPosZ = m.pos.z

    local cam = gLakituState
    if not cam then return end
    local camYaw = calculate_yaw(cam.goalPos, cam.goalFocus)

    o.oPosX = o.oPosX + sins(camYaw) * 100
    o.oPosZ = o.oPosZ + coss(camYaw) * 100
end

id_bhvSplashEffect = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, true, splash_effect_init, splash_effect_loop, "bhvSplashEffect")

-- strawberry switch, based on the blue coin switch
function strawberry_switch_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oAnimState = o.oBehParams2ndByte
    o.collisionData = smlua_collision_util_get("berrySwitch_collision")
    o.oHomeY = o.oPosY
    o.oFaceAnglePitch, o.oFaceAngleYaw, o.oFaceAngleRoll = 0, 0, 0
    cur_obj_scale(0.5)

    spawn_non_sync_object(id_bhvStrawberrySwitchBase, E_MODEL_STRAWBERRY_SWITCH_BASE, o.oPosX, o.oPosY - 32.5, o.oPosZ, function(o2)
        o2.oBehParams = o.oBehParams
        o2.oBehParams2ndByte = o.oBehParams2ndByte
        o2.parentObj = o
    end)
end

function strawberry_switch_loop(o)
    -- check for strawberry
    local strawberryActive = false
    local strawberry = obj_get_first_with_behavior_id_and_field_s32(id_bhvStrawberry, 0x2F, o.oBehParams2ndByte) -- 0x2F is "oBehParams2ndByte"
    if (strawberry and strawberry.oAction == 0 and strawberry.oSubAction == 0) then
        strawberryActive = true
    end

    if o.oAction == BLUE_COIN_SWITCH_ACT_IDLE then
        -- If Mario is on the switch and has ground-pounded,
        -- recede and get ready to start ticking.
        if (not strawberryActive) or ((gMarioStates[0].marioObj and gMarioStates[0].marioObj.platform == o) and gMarioStates[0].action & MARIO_UNKNOWN_13 == 0) then
            -- Set to BLUE_COIN_SWITCH_ACT_RECEDING
            o.oAction = o.oAction + 1

            switch_set_timer_display(o, strawberryActive, o.oBehParams)

            cur_obj_play_sound_2(SOUND_GENERAL_SWITCH_DOOR_OPEN)
        elseif strawberryActive and dist_between_objects(o, gMarioStates[0].marioObj) < 300 then
            switch_set_timer_display(o, strawberryActive, o.oBehParams)
        elseif dispBlueCoinTimer == o.oBehParams2ndByte then
            dispBlueCoinTimer = 0
            if not prevDispHudTimer then
                hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) & ~HUD_DISPLAY_FLAGS_TIMER)
            end
        end

        cur_obj_scale(0.5)
    elseif o.oAction == BLUE_COIN_SWITCH_ACT_RECEDING then
        lastSwitchLevel = gNetworkPlayers[0].currLevelNum
        lastSwitchPos = {x = o.oPosX, y = o.oPosY + 300, z = o.oPosZ}

        switch_set_timer_display(o, strawberryActive, o.oBehParams)

        -- Recede for 6 frames before ticking.
        if (o.oTimer > 5) then
            o.header.gfx.scale.y = 0.2

            -- Set to BLUE_COIN_SWITCH_ACT_TICKING
            o.oAction = o.oAction + 1
        else
            -- Recede
            cur_obj_scale_over_time(2, 5, 0.5, 0.2)
        end
    elseif o.oAction == BLUE_COIN_SWITCH_ACT_TICKING then
        -- Tick faster when the strawberry starts blinking
        switch_set_timer_display(o, strawberryActive, o.oBehParams - o.oTimer)
        hud_set_value(HUD_DISPLAY_TIMER, o.oBehParams - o.oTimer)
        if strawberryActive then
            if (o.oTimer < o.oBehParams - 40) then
                play_sound(SOUND_GENERAL2_SWITCH_TICK_FAST, gGlobalSoundSource)
            else
                play_sound(SOUND_GENERAL2_SWITCH_TICK_SLOW, gGlobalSoundSource)
            end
        end

        -- Respawn the switch (which stops the sound) after the strawberry is collected/inactive,
        -- or after the timer expires.
        if (not strawberryActive) or o.oTimer > o.oBehParams then
            o.oAction = BLUE_COIN_SWITCH_ACT_RESPAWNING
            if strawberryActive then
                cur_obj_play_sound_2(SOUND_GENERAL_SWITCH_DOOR_OPEN)
            end
            if dispBlueCoinTimer ~= 0 and not prevDispHudTimer then
                hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) & ~HUD_DISPLAY_FLAGS_TIMER)
            end
            dispBlueCoinTimer = 0
        end
    elseif o.oAction == BLUE_COIN_SWITCH_ACT_RESPAWNING then
        if strawberryActive then
            -- Grow back for 6 frames before returning to normal action.
            if (o.oTimer > 5) then
                o.header.gfx.scale.y = 0.5

                -- Set to BLUE_COIN_SWITCH_ACT_IDLE
                o.oAction = BLUE_COIN_SWITCH_ACT_IDLE
            else
                -- Grow
                cur_obj_scale_over_time(2, 5, 0.2, 0.5)
            end
            cur_obj_unhide()
        elseif obj_is_hidden(o) == 0 then
            cur_obj_hide()
            spawn_mist_particles()
        end
    end

    if obj_is_hidden(o) == 0 then
        load_object_collision_model()
    end
end

function switch_set_timer_display(o, strawberryActive, timer)
    local hudFlags = hud_get_value(HUD_DISPLAY_FLAGS)
    if strawberryActive and dispBlueCoinTimer == 0 then
        prevDispHudTimer = (hudFlags & HUD_DISPLAY_FLAGS_TIMER ~= 0)
        hud_set_value(HUD_DISPLAY_FLAGS, hudFlags | HUD_DISPLAY_FLAGS_TIMER)
        dispBlueCoinTimer = o.oBehParams2ndByte
    end
    hud_set_value(HUD_DISPLAY_TIMER, timer)
end

id_bhvStrawberrySwitch = hook_behavior(nil, OBJ_LIST_SURFACE, true, strawberry_switch_init, strawberry_switch_loop, "bhvStrawberrySwitch")

-- strawberry switch base
function strawberry_switch_base_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oAnimState = o.oBehParams2ndByte
    o.collisionData = smlua_collision_util_get("berrySwitchBase_collision")
    o.oHomeY = o.oPosY
    o.oFaceAnglePitch, o.oFaceAngleYaw, o.oFaceAngleRoll = 0, 0, 0
    cur_obj_scale(0.5)
end

function strawberry_switch_base_loop(o)
    if o.parentObj == o or o.parentObj == nil then
        obj_mark_for_deletion(o)
        return
    end

    if obj_is_hidden(o.parentObj) ~= 0 then
        cur_obj_hide()
        return
    end

    cur_obj_unhide()
    load_object_collision_model()
end

id_bhvStrawberrySwitchBase = hook_behavior(nil, OBJ_LIST_SURFACE, true, strawberry_switch_base_init, strawberry_switch_base_loop, "bhvStrawberrySwitchBase")

---@param m MarioState
function act_strawberry_get(m)
    m.vel.y = 0
    mario_set_forward_vel(m, 0)
    m.actionTimer = m.actionTimer + 1
    if m.actionTimer == 1 then
        play_secondary_music(0, 0, 0, 0)
        if m.actionArg == 0 then
            play_celeste_sound("strawbGet", m, 2)
        elseif m.actionArg == 1 then
            play_celeste_sound("strawbGetGold", m, 0.5)
        elseif m.actionArg == 2 then
            play_celeste_sound("strawbGetMoon", m, 0.4)
        end

        if m.playerIndex == 0 then
            disable_background_sound()
            spawn_sync_object(id_bhvSplashEffect, E_MODEL_SPLASH, m.pos.x, m.pos.y + 80, m.pos.z, function(o)
                o.globalPlayerIndex = network_global_index_from_local(0)
            end)
            m.faceAngle.y = m.area.camera.yaw
            start_cutscene(m.area.camera, CUTSCENE_LOOP)
            if (m.area.camera.mode == CAMERA_MODE_WATER_SURFACE or m.area.camera.mode == CAMERA_MODE_BEHIND_MARIO) then
                set_camera_mode(m.area.camera, m.area.camera.defMode, 0)
            end
            if gCelesteStates[0].movesetDisabled then
                djui_chat_message_create("Woah, you got this strawberry without the Celeste Moveset!")
                djui_chat_message_create("Impressive! Send me a clip if you can!")
                djui_chat_message_create("(Unless it's the THI one I know that one's possible)")
            end
        end
    elseif m.actionTimer >= STRAWB_GET_TIME then
        m.forwardVel = 0
        m.vel.y = 30
        if m.input & INPUT_NONZERO_ANALOG ~= 0 then
            m.faceAngle.y = m.intendedYaw
        end
        if m.waterLevel < m.pos.y then
            set_mario_action(m, ACT_FREEFALL, 0)
        else
            set_mario_action(m, ACT_WATER_IDLE, 0)
        end
        if m.playerIndex == 0 then
            enable_background_sound()
            m.area.camera.cutscene = 0
            --play_cutscene(m.area.camera)
            stop_secondary_music(500)
        end
        return
    end

    m.faceAngle.x, m.faceAngle.z = 0, 0
    m.marioBodyState.handState = MARIO_HAND_RIGHT_OPEN
    set_mario_animation(m, MARIO_ANIM_SINGLE_JUMP)
    set_anim_to_frame(m, 100)
    m.marioBodyState.eyeState = MARIO_EYES_OPEN
    vec3f_copy(m.marioObj.header.gfx.pos, m.pos);
    vec3f_copy(m.marioObj.header.gfx.angle, m.faceAngle);

    -- focus in front of mario
    if m.playerIndex == 0 then
        local speed = 0.15
        local goalFocus = { x = 0, y = 0, z = 0 }
        local goalPos = { x = 0, y = 0, z = 0 }
        local offsetFocus = { x = 0, y = 150, z = -100 }
        local offsetPos = { x = 0, y = 350, z = -500 }

        offset_rotated(goalFocus, m.pos, offsetFocus, m.faceAngle)
        offset_rotated(goalPos, m.pos, offsetPos, m.faceAngle);
        approach_vec3f_asymptotic(gLakituState.goalFocus, goalFocus, speed, speed, speed);
        approach_vec3f_asymptotic(gLakituState.goalPos, goalPos, speed, speed, speed);
    end

    local o = m.usedObj
    if obj_has_behavior_id(o, id_bhvStrawberry) ~= 0 and o.oAction == 1 then
        o.oPosX = m.pos.x
        o.oPosY = m.pos.y + 180
        o.oPosZ = m.pos.z
        o.oFaceAngleYaw = m.faceAngle.y
    end
end

-- grab strawberry action (ACT_FLAG_HANGING is specifically for the camera)
ACT_STRAWBERRY_GET = allocate_mario_action(ACT_GROUP_CUTSCENE | ACT_FLAG_STATIONARY | ACT_FLAG_INTANGIBLE | ACT_FLAG_HANGING)

hook_mario_action(ACT_STRAWBERRY_GET, act_strawberry_get)

-- hud
local prevStrawBerryCount = -1
local hudBounceTimer = 0
function strawberry_hud()
    if not strawberriesExist then return end

    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_set_font(FONT_HUD)

    local screenWidth = djui_hud_get_screen_width()
    local x = screenWidth - 102
    local y = 36
    if _G.PersonalStarCounter then
        y = y + 32
        if hud_get_value(HUD_DISPLAY_FLAGS) & HUD_DISPLAY_FLAG_TIMER ~= 0 then
            y = y + 10
        end
    elseif hud_get_value(HUD_DISPLAY_FLAGS) & HUD_DISPLAY_FLAG_TIMER ~= 0 then
        y = y + 24
    end
    local scale = 1

    local m = gMarioStates[0]
    local collectedData = gGlobalSyncTable.strawbData
    local total = TOTAL_STRAWBERRIES
    local tex = TEX_STRAWBERRY
    if gGlobalSyncTable.moonStrawbData ~= 0 then
        collectedData = gGlobalSyncTable.moonStrawbData
        total = TOTAL_STRAWBERRIES_MOON
        tex = TEX_STRAWBERRY_MOON
    elseif gGlobalSyncTable.goldStrawbData ~= 0 then
        collectedData = gGlobalSyncTable.goldStrawbData
        total = TOTAL_STRAWBERRIES_GOLD
        tex = TEX_STRAWBERRY_GOLD
    end

    if is_game_paused() and m.action ~= ACT_EXIT_LAND_SAVE_DIALOG then
        if gGlobalSyncTable.strawbData ~= 0 then
            render_single_strawb_number(gGlobalSyncTable.strawbData, x, y, scale, TOTAL_STRAWBERRIES, TEX_STRAWBERRY, true)
            y = y + 20
        end
        if gGlobalSyncTable.goldStrawbData ~= 0 then
            render_single_strawb_number(gGlobalSyncTable.goldStrawbData, x, y, scale, TOTAL_STRAWBERRIES_GOLD, TEX_STRAWBERRY_GOLD, true)
            y = y + 20
        end
        if gGlobalSyncTable.moonStrawbData ~= 0 then
            render_single_strawb_number(gGlobalSyncTable.moonStrawbData, x, y, scale, TOTAL_STRAWBERRIES_MOON, TEX_STRAWBERRY_MOON, true)
        end
        return
    elseif collectedData == 0 or hud_is_hidden() or m.action == ACT_CREDITS_CUTSCENE or m.action == ACT_END_PEACH_CUTSCENE or m.action == ACT_END_WAVING_CUTSCENE or obj_get_first_with_behavior_id(id_bhvActSelector) then
        if collectedData == 0 then
            prevStrawBerryCount = 0
        end
        hudBounceTimer = 0
        return
    end

    render_single_strawb_number(collectedData, x, y, scale, total, tex)
end
hook_event(HOOK_ON_HUD_RENDER_BEHIND, strawberry_hud)

-- menu + radar for some goldens and moons
local berry_radar = {}
local starsInActSelect = 0
local strawbMenuOpen = false
table.insert(berry_radar, {prevX = 0, prevY = 0, prevScale = 0, inited = false})
table.insert(berry_radar, {prevX = 0, prevY = 0, prevScale = 0, inited = false})
function on_hud_render()
    if (not strawberriesExist) then return end

    if strawbMenuOpen then
        render_strawb_menu()
        return
    elseif (is_game_paused() and gMarioStates[0].action ~= ACT_EXIT_LAND_SAVE_DIALOG) and not djui_hud_is_pause_menu_created() then
        djui_hud_set_color(255, 255, 255, 255)
        djui_hud_set_resolution(RESOLUTION_DJUI)
        local text = "L Button - Strawberries"
        local width = djui_hud_measure_text(text)
        local x = (djui_hud_get_screen_width() - width) / 2
        local y = 48
        djui_hud_print_text(text, x, y, 1)
    end

    djui_hud_set_resolution(RESOLUTION_N64)

    local m = gMarioStates[0]
    local actSelect = obj_get_first_with_behavior_id(id_bhvActSelector)
    if actSelect or hud_is_hidden() or m.action == ACT_CREDITS_CUTSCENE or m.action == ACT_END_PEACH_CUTSCENE or m.action == ACT_END_WAVING_CUTSCENE then
        for type=1,2 do
            if actSelect then
                local np = gNetworkPlayers[0]
                local berryLocation = strawberry_pos[type+1][np.currLevelNum]
                if ((type == 1 and gGlobalSyncTable.redBerryDone) or (type == 2 and gGlobalSyncTable.goldBerryDone)) and berryLocation and berryLocation[6] then
                    local tex = TEX_STRAWBERRY_GOLD
                    local width = 16
                    local height = 19
                    if type == 2 then
                        tex = TEX_STRAWBERRY_MOON
                        width = 21
                    end

                    if starsInActSelect == 0 then
                        local stars = save_file_get_star_flags(get_current_save_file_num() - 1, np.currCourseNum - 1)
                        starsInActSelect = 1
                        for i=5,0,-1 do
                            if stars & (1 << i) ~= 0 then
                                starsInActSelect = math.min(i+2, 6)
                                break
                            end
                        end
                    end

                    local act = berryLocation[6]
                    if act <= starsInActSelect then
                        local x = (-starsInActSelect * 17 + act * 34) + djui_hud_get_screen_width() * 0.5 - 6
                        if type == 2 then
                            x = x - 20
                        end
                        local y = 50
                        local scale = 1
                        local halfWidth = (width / 2) * scale
                        local halfHeight = (height / 2) * scale
                        djui_hud_set_color(255, 255, 255, 155)
                        djui_hud_render_texture(tex, x - halfWidth, y - halfHeight, scale, scale)
                    end
                end
            end
            berry_radar[type].inited = false
        end
        return
    end
    starsInActSelect = 0

    local np = gNetworkPlayers[0]
    for type=1,2 do
        local berryLocation = strawberry_pos[type+1][np.currLevelNum]
        local rendered = false
        local radar = berry_radar[type]
        if ((type == 1 and gGlobalSyncTable.redBerryDone) or (type == 2 and gGlobalSyncTable.goldBerryDone)) and berryLocation and berryLocation[7] and np.currAreaIndex == berryLocation[4] and (berryLocation[6] == nil or np.currActNum == berryLocation[6]) and not is_berry_collected(berryLocation[5], type) then
            local strawberry = obj_get_first_with_behavior_id_and_field_s32(id_bhvStrawberry, 0x2F, type) -- 0x2F is "oBehParams2ndByte"
            if strawberry and strawberry.header.gfx.node.flags & GRAPH_RENDER_ACTIVE ~= 0 and strawberry.header.gfx.node.flags & GRAPH_RENDER_INVISIBLE == 0 then
                local pos = {x = strawberry.oPosX, y = strawberry.oPosY, z = strawberry.oPosZ}
                local out = {x = 0, y = 0, z = 0}
                if djui_hud_world_pos_to_screen_pos(pos, out) and out.z ~= 0 then
                    local scale = math.max(0.25, -1600 / out.z * djui_hud_get_fov_coeff())
                    local alpha = clamp(255 / scale - 100, 0, 255)
                    if alpha ~= 0 then
                        local tex = TEX_STRAWBERRY_GOLD
                        local width = 16
                        local height = 19
                        if type == 2 then
                            tex = TEX_STRAWBERRY_MOON
                            width = 21
                        end

                        local x = out.x
                        local y = out.y
                        if strawberry_switch[type+1] and strawberry_switch[type+1][berryLocation[5]] then
                            scale = 0.5
                            alpha = 200
                            local halfWidth = (width / 2) * scale
                            local halfHeight = (height / 2) * scale
                            local screenWidth = djui_hud_get_screen_width()
                            local screenHeight = djui_hud_get_screen_height()
                            if x < halfWidth then
                                x = halfWidth
                            elseif x > screenWidth - halfWidth then
                                x = screenWidth - halfWidth
                            end
                            if y < halfHeight then
                                y = halfHeight
                            elseif y > screenHeight - halfHeight then
                                y = screenHeight - halfHeight
                            end
                        end
                        
                        if not radar.inited then
                            radar.prevX = x
                            radar.prevY = y
                            radar.prevScale = scale
                            radar.inited = true
                        end

                        local halfWidth = (width / 2) * scale
                        local halfHeight = (height / 2) * scale
                        local prevHalfWidth = (width / 2) * radar.prevScale
                        local prevHalfHeight = (height / 2) * radar.prevScale
                        
                        djui_hud_set_color(255, 255, 255, alpha)
                        djui_hud_set_rotation(0, 0, 0)
                        djui_hud_render_texture_interpolated(tex, radar.prevX - prevHalfWidth, radar.prevY - prevHalfHeight, radar.prevScale, radar.prevScale, x - halfWidth, y - halfHeight, scale, scale)

                        radar.prevX = x
                        radar.prevY = y
                        radar.prevScale = scale
                        rendered = true
                    end
                end
            end
        end
        if not rendered then
            radar.inited = false
        end
    end
end
hook_event(HOOK_ON_HUD_RENDER, on_hud_render)

function render_single_strawb_number(collectedData, x, y, scale, total, tex, noBounce)
    local strawberryCount = 0
    for i = 1, total do
        if collectedData & (1 << (i - 1)) ~= 0 then
            strawberryCount = strawberryCount + 1
        end
    end

    if not noBounce then
        if prevStrawBerryCount == -1 then
            prevStrawBerryCount = strawberryCount
        elseif prevStrawBerryCount ~= strawberryCount then
            if delayStrawberryUpdate == 0 then
                prevStrawBerryCount = strawberryCount
                hudBounceTimer = 20
            else
                strawberryCount = prevStrawBerryCount
                delayStrawberryUpdate = delayStrawberryUpdate - 1
            end
        end
    end
    
    local offset = 0
    local tOffset = 0
    local texOffset = 0
    -- hud bounces when updating strawberry count, like in celeste 64
    if (not noBounce) and hudBounceTimer ~= 0 then
        hudBounceTimer = hudBounceTimer - 1
        scale = scale - sins(hudBounceTimer*0x2000) * (hudBounceTimer / 40)
        offset = 16 - 16 * scale
        tOffset = djui_hud_measure_text("00")
        tOffset = tOffset - tOffset * scale
    end
    if tex == TEX_STRAWBERRY_MOON then -- this is a bit big, so move it left
        texOffset = 6
    end
    djui_hud_render_texture(tex, x+offset-texOffset, y+offset-3, scale, scale)
    x = x + 16
    djui_hud_print_text(string.format("%02d", strawberryCount), x+tOffset, y+offset, scale)
    x = x + 24
    djui_hud_print_text("/", x+offset, y+offset, scale)
    x = x + 14
    djui_hud_print_text(string.format("%02d", total), x+tOffset, y+offset, scale)
end

local strawbMenuInputsDown = 0
local strawbMenuInputsPressed = 0
local strawbMenuTab = 0
local strawbMenuLastDir = 0
local strawbMenuDirTimer = 0
function handle_strawb_menu_inputs(m)
    if m.playerIndex ~= 0 then return end

    -- open menu with L in the pause menu
    if not strawbMenuOpen then
        if not strawberriesExist then return end
        
        if (is_game_paused() and m.action ~= ACT_EXIT_LAND_SAVE_DIALOG) and m.controller.buttonPressed & L_TRIG ~= 0 then
            strawbMenuOpen = true
            -- m.controller.buttonPressed = m.controller.buttonPressed | START_BUTTON
            -- strawbMenuInputsDown = m.controller.buttonDown
        else
            return
        end
    end

    strawbMenuInputsPressed = m.controller.buttonDown & ~strawbMenuInputsDown
    strawbMenuInputsDown = m.controller.buttonDown
    m.controller.buttonPressed = 0
    m.controller.buttonDown = 0
    m.freeze = math.max(m.freeze, 2)
    
    local TOTAL_TABS = 3
    if not gGlobalSyncTable.redBerryDone then
        TOTAL_TABS = TOTAL_TABS - 1
    end
    if not gGlobalSyncTable.goldBerryDone then
        TOTAL_TABS = TOTAL_TABS - 1
    end

    if strawbMenuInputsPressed & START_BUTTON ~= 0 then
        play_sound(SOUND_MENU_PAUSE_2, gGlobalSoundSource)
        strawbMenuOpen = false
        m.controller.buttonPressed = START_BUTTON
        --m.controller.buttonDown = START_BUTTON
        return
    elseif strawbMenuInputsPressed & B_BUTTON ~= 0 then
        strawbMenuOpen = false
    elseif strawbMenuInputsPressed & R_TRIG ~= 0 then
        djui_open_pause_menu()
    end
    
    if TOTAL_TABS > 1 and (m.controller.rawStickX > 48 or m.controller.rawStickX < -48) then
        local currDir = 0
        if m.controller.rawStickX > 48 then
            currDir = 1
        else
            currDir = -1
        end

        local doInput = false
        if strawbMenuLastDir ~= currDir or strawbMenuDirTimer == 0 then
            strawbMenuLastDir = currDir
            strawbMenuDirTimer = 10
            doInput = true
        else
            strawbMenuDirTimer = strawbMenuDirTimer - 1
            if strawbMenuDirTimer == 0 then
                strawbMenuDirTimer = 5
                doInput = true
            end
        end

        if doInput then
            strawbMenuTab = (strawbMenuTab + strawbMenuLastDir) % TOTAL_TABS
            play_sound(SOUND_MENU_CHANGE_SELECT, gGlobalSoundSource)
        end
    else
        strawbMenuDirTimer = 0
    end

    m.controller.stickX = 0
    m.controller.stickY = 0
    m.controller.extStickX = 0
    m.controller.extStickY = 0
    m.controller.rawStickX = 0
    m.controller.rawStickY = 0
end

hook_event(HOOK_BEFORE_MARIO_UPDATE, handle_strawb_menu_inputs)

function handle_strawb_menu_inputs_singleplayer()
    if not strawberriesExist then return end
    
    local m = gMarioStates[0]
    if (is_game_paused() and m.action ~= ACT_EXIT_LAND_SAVE_DIALOG) and network_check_singleplayer_pause() then
        handle_strawb_menu_inputs(m)
    end
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, handle_strawb_menu_inputs_singleplayer)

function render_strawb_menu()
    if djui_hud_is_pause_menu_created() then return end
    djui_hud_set_resolution(RESOLUTION_N64)

    local screenWidth = djui_hud_get_screen_width()
    local screenHeight = djui_hud_get_screen_height()
    djui_hud_set_color(0, 0, 0, 200)
    djui_hud_render_rect(0, 0, screenWidth + 10, screenHeight + 10)

    local TOTAL_TABS = 3
    if not gGlobalSyncTable.redBerryDone then
        TOTAL_TABS = TOTAL_TABS - 1
    end
    if not gGlobalSyncTable.goldBerryDone then
        TOTAL_TABS = TOTAL_TABS - 1
    end

    djui_hud_set_color(255, 255, 255, 255)
    local strawbMenuData = {
        {TEX_STRAWBERRY, 16, "Can you find all \\#ff3428\\"..TOTAL_STRAWBERRIES.." hidden strawberries\\#ffff50\\?", "You got all \\#ff3428\\red strawberries\\#ffff50\\! Great job!"},
        {TEX_STRAWBERRY_GOLD, 16, "These \\#ffe000\\"..TOTAL_STRAWBERRIES_GOLD.."  are more challenging,\nand some are even inside of walls!\nYou may not use cannons or the Wing Cap.", "Wow, you got all \\#ffe000\\golden strawberries\\#ffff50\\? Incredible!\nBut can you go higher?"},
        {TEX_STRAWBERRY_MOON, 22, "WARNING: These \\#35ff7b\\"..TOTAL_STRAWBERRIES_MOON.." moon berries\\#ffff50\\ are incredibly difficult!\nMany of them are inside of walls!\nYou may not use cannons or the Wing Cap.", "Holy cow, you managed to collect all \\#35ff7b\\moon berries\\#ffff50\\?\nYou are a super player!"},
    }
    local tex = TEX_STRAWBERRY
    local x = screenWidth / 2 - (TOTAL_TABS - 1) * 10
    local y = 16
    local scale = 1
    for i=0,TOTAL_TABS-1 do
        scale = (strawbMenuTab == i and 1) or 0.75
        tex = strawbMenuData[i+1][1]
        djui_hud_render_texture(tex, x - (strawbMenuData[i+1][2]/2)*scale, y, scale, scale)
        x = x + 20
    end

    y = 40
    scale = 0.3
    local text = strawbMenuData[strawbMenuTab+1][3]
    local gotAll = false
    if (strawbMenuTab == 0 and gGlobalSyncTable.redBerryDone) or (strawbMenuTab == 1 and gGlobalSyncTable.goldBerryDone) or (strawbMenuTab == 2 and gGlobalSyncTable.moonBerryDone) then
        text = strawbMenuData[strawbMenuTab+1][4]
        gotAll = true
    end
    djui_hud_set_color(255, 255, 80, 255)
    if invalid_strawberry_options() then
        text = "Disable all \\#FD6A62\\pink options\\#ffff50\\ to access strawberries!"
    end
    local lines = split(text, "\n")
    if strawbMenuTab ~= 0 and not (gotAll or gGlobalSyncTable.allowQuickReset) then
        table.insert(lines, "\\#50ff50\\Enabling Quick Reset in the mod menu is highly recommended.")
    end
    for i,line in ipairs(lines) do
        local width = djui_hud_measure_text(remove_color(line)) * scale
        x = (screenWidth-width) / 2
        djui_hud_print_text_with_color(line, x, y, scale)
        y = y + 32 * scale
    end
    
    x = screenWidth / 2
    y = y + 32 * scale
    scale = 0.25
    for i,hint in ipairs(strawberry_hints[strawbMenuTab+1]) do
        djui_hud_set_color(255, 80, 80, 255)
        if is_berry_collected(i, strawbMenuTab) then
            djui_hud_set_color(255, 255, 80, 255)
            local name = gotStrawberryList[strawbMenuTab*100+i]
            if name then
                hint = hint .. " (" .. name .. "\\#ffff50\\)"
            end
        end

        local tx = 0
        if i % 2 ~= 0 then
            local width = djui_hud_measure_text(remove_color(hint)) * scale
            tx = -width - 10
            if i ~= 1 then
                y = y + 48 * scale
            end
        else
            tx = 10
        end
        djui_hud_print_text_with_color(hint, x+tx, y, scale)
    end
end

-- send strawberry collection list to joining players
function on_connected(m)
    if not strawberriesExist then return end
    if network_is_server() and m.playerIndex ~= 0 then
        network_send_to(m.playerIndex, true, gotStrawberryList)
    end
end

hook_event(HOOK_ON_PLAYER_CONNECTED, on_connected)

-- don't update mario's geometry inputs if he's above a non-slippery surface and this is a slide level.
-- this prevents switches from being slippery.
function mario_geometry_inputs(m)
    if not strawberriesExist then return end

    if m.area.terrainType == TERRAIN_SLIDE and mario_get_floor_class(m) == SURFACE_CLASS_NOT_SLIPPERY then
        m.input = m.input & ~INPUT_ABOVE_SLIDE
        return false
    end
end
hook_event(HOOK_MARIO_OVERRIDE_GEOMETRY_INPUTS, mario_geometry_inputs)

-- packets
function on_packet_strawb_get(data, self)
    if not strawberriesExist then return end
    
    if data.newStrawb then
        local np = network_player_from_global_index(data.from)
        if np then
            local playerColor = network_get_player_text_color_string(np.localIndex)
            local name = playerColor .. np.name
            local maxLength = 11 * 16
            if data.strawbType == 1 then maxLength = maxLength - 4 * 16 end
            if self then
                name = "\\#ffffff\\You"
            elseif djui_hud_measure_text(remove_color(name)) >= maxLength then
                name = name .. "\n"
            end
            --djui_chat_message_create(tostring(djui_hud_measure_text(remove_color(name))))
            local hint = (strawberry_hints[data.strawbType+1] and strawberry_hints[data.strawbType+1][data.strawb]) or "REPORT THIS AS A BUG"
            if data.strawbType == 1 then
                djui_popup_create(name .. "\\#ffffff\\ found a \\#ffe000\\Golden Strawberry!\n\\#ffffff\\"..hint, 2)
            elseif data.strawbType == 2 then
                djui_popup_create(name .. "\\#ffffff\\ found a \\#35ff7b\\Moon Berry!\n\\#ffffff\\"..hint, 2)
            else
                djui_popup_create(name .. "\\#ffffff\\ found a \\#ff3428\\Strawberry!\n\\#ffffff\\"..hint, 2)
            end

            gotStrawberryList[data.strawbType*100+data.strawb] = (playerColor .. np.name)
        end
    end

    if network_is_server() and not is_berry_collected(data.strawb, data.strawbType) then
        local strawbString = "strawb_" .. prevSaveFile .. "_" .. tostring(data.strawb)
        if data.strawbType and data.strawbType ~= 0 then
            strawbString = strawbString .. "_" .. tostring(data.strawbType)
        end
        mod_storage_save_bool(strawbString, true)

        if data.strawbType == 0 then
            gGlobalSyncTable.strawbData = gGlobalSyncTable.strawbData | (1 << (data.strawb - 1))
        elseif data.strawbType == 1 then
            gGlobalSyncTable.goldStrawbData = gGlobalSyncTable.goldStrawbData | (1 << (data.strawb - 1))
        elseif data.strawbType == 2 then
            gGlobalSyncTable.moonStrawbData = gGlobalSyncTable.moonStrawbData | (1 << (data.strawb - 1))
        end
        save_file_do_save(get_current_save_file_num() - 1, 1)

        if data.strawbType == 0 and gGlobalSyncTable.strawbData >= ((1 << TOTAL_STRAWBERRIES) - 1) then
            network_send_include_self(true, {
                id = PACKET_GOT_ALL_STRAWBS,
                type = 0,
                new = (not gGlobalSyncTable.redBerryDone),
                newUnlock = (not gGlobalSyncTable.dashCountUnlocked),
            })
        elseif data.strawbType == 1 and gGlobalSyncTable.goldStrawbData >= ((1 << TOTAL_STRAWBERRIES_GOLD) - 1) then
            network_send_include_self(true, {
                id = PACKET_GOT_ALL_STRAWBS,
                type = 1,
                new = (not gGlobalSyncTable.goldBerryDone),
                newUnlock = (not gGlobalSyncTable.infStaminaUnlocked),
            })
        elseif data.strawbType == 2 and gGlobalSyncTable.moonStrawbData >= ((1 << TOTAL_STRAWBERRIES_MOON) - 1) then
            network_send_include_self(true, {
                id = PACKET_GOT_ALL_STRAWBS,
                type = 2,
                new = (not gGlobalSyncTable.moonBerryDone),
                newUnlock = (not gGlobalSyncTable.superDashUnlocked),
            })
        end
    end
end

function on_packet_got_all_strawbs(data, self)
    if not strawberriesExist then return end

    if data.type == 0 then
        djui_chat_message_create("All strawberries have been collected!")
        mod_storage_save_bool("redBerryDone", true)
        if not data.new then return end
        djui_chat_message_create("Unlocked golden strawberries! (/sb_info)")
        --update_chat_command_description("sb_info", "[LIST|GOLD|GOLDLIST] - Get info about strawberries")
        if network_is_server() then
            gGlobalSyncTable.redBerryDone = true
            add_dash_count_menu()
        end
        if data.newUnlock then
            djui_chat_message_create("HOST ONLY: Unlocked dash count option!")
        end
    elseif data.type == 1 then
        djui_chat_message_create("All golden strawberries have been collected!")
        mod_storage_save_bool("goldBerryDone", true)
        if not data.new then return end
        djui_chat_message_create("Unlocked moon berries! (/sb_info)")
        --update_chat_command_description("sb_info", "[LIST|GOLD|GOLDLIST|MOON|MOONLIST] - Get info about strawberries")
        if network_is_server() then
            gGlobalSyncTable.goldBerryDone = true
            add_infinite_stamina_menu()
        end
        if data.newUnlock then
            djui_chat_message_create("HOST ONLY: Unlocked infinite stamina option!")
        end
    elseif data.type == 2 then
        djui_chat_message_create("All moon berries have been collected!")
        mod_storage_save_bool("moonBerryDone", true)
        if not data.new then return end
        djui_chat_message_create("Unlocked nova berries- haha I'm kidding. You are a super player!")
        if network_is_server() then
            gGlobalSyncTable.moonBerryDone = true
            add_super_dash_menu()
        end
        if data.newUnlock then
            djui_chat_message_create("HOST ONLY: Unlocked Super Dash option!")
        end
    end
end

function on_packet_collect_list(data, self)
    gotStrawberryList = data
end

PACKET_STRAWB_GET = 0
PACKET_GOT_ALL_STRAWBS = 1
PACKET_COLLECT_LIST = 2
gotStrawberryList.id = PACKET_COLLECT_LIST
local sPacketTable = {
    [PACKET_STRAWB_GET] = on_packet_strawb_get,
    [PACKET_GOT_ALL_STRAWBS] = on_packet_got_all_strawbs,
    [PACKET_COLLECT_LIST] = on_packet_collect_list,
}
function on_packet_recieve(data)
    if data.id and sPacketTable[data.id] then
        sPacketTable[data.id](data, false)
    end
end

hook_event(HOOK_ON_PACKET_RECEIVE, on_packet_recieve)

function network_send_to_host(reliable, data)
    if network_is_server() then
        if data.id and sPacketTable[data.id] then
            sPacketTable[data.id](data, true)
        end
    else
        network_send_to(1, reliable, data)
    end
end

function network_send_include_self(reliable, data)
    network_send(reliable, data)
    if data.id and sPacketTable[data.id] then
        sPacketTable[data.id](data, true)
    end
end

-- hint command
function strawberry_hint_command(msg_)
    local msg = msg_ and msg_:lower()
    if msg == "list" then
        djui_chat_message_create("\\#ff3428\\Strawberries:")
        for id,hint in ipairs(strawberry_hints[1]) do
            local color = "\\#ffff50\\"
            if not is_berry_collected(id, 0) then
                color = "\\#ff5050\\" -- red if not collected
            end
            djui_chat_message_create(color..hint)
        end
        djui_chat_message_create("\\#ffff50\\(Scroll up for more)")
    elseif msg == "goldlist" then
        if not gGlobalSyncTable.redBerryDone then
            djui_chat_message_create("\\#ff5050\\You need to collect all normal strawberries first!")
            return true
        end
        djui_chat_message_create("\\#ffe000\\Golden Strawberries:")
        for id,hint in ipairs(strawberry_hints[2]) do
            local color = "\\#ffff50\\"
            if not is_berry_collected(id, 1) then
                color = "\\#ff5050\\" -- red if not collected
            end
            djui_chat_message_create(color..hint)
        end
        djui_chat_message_create("\\#ffff50\\(Scroll up for more)")
    elseif msg == "moonlist" then
        if not gGlobalSyncTable.goldBerryDone then
            djui_chat_message_create("\\#ff5050\\You need to collect all golden strawberries first!")
            return true
        end
        djui_chat_message_create("\\#35ff7b\\Moon Berries:")
        for id,hint in ipairs(strawberry_hints[3]) do
            local color = "\\#ffff50\\"
            if not is_berry_collected(id, 2) then
                color = "\\#ff5050\\" -- red if not collected
            end
            djui_chat_message_create(color..hint)
        end
        djui_chat_message_create("\\#ffff50\\(Scroll up for more)")
    else
        if msg == "gold" and not gGlobalSyncTable.redBerryDone then
            djui_chat_message_create("\\#ff5050\\You need to collect all normal strawberries first!")
            return true
        elseif msg == "moon" and not gGlobalSyncTable.goldBerryDone then
            djui_chat_message_create("\\#ff5050\\You need to collect all golden strawberries first!")
            return true
        end
        local strawbNumber = tostring(TOTAL_STRAWBERRIES)
        local strawbName = "strawberries"
        local rules = "You must have all \\#FD6A62\\pink options\\#ffff50\\ disabled."
        local hint = "There is 1 in every course and secret stage (except The Secret Aquarium), and 2 somewhere around the castle."
        local listStr = "list"
        if msg == "gold" then
            strawbNumber = tostring(TOTAL_STRAWBERRIES_GOLD)
            strawbName = "golden strawberries"
            rules = "You must have all \\#FD6A62\\pink options\\#ffff50\\ disabled.\nCannons and the Wing Cap may not be used.\nNote that some golden strawberries are out-of-bounds."
            hint = "There is 1 in every course and secret stage (except The Secret Aquarium and Tower Of The Wing Cap), and 2 somewhere around the castle."
            listStr = "goldlist"
        elseif msg == "moon" then
            strawbNumber = tostring(TOTAL_STRAWBERRIES_MOON)
            strawbName = "moon berries"
            rules = "The rules are the same as for golden berries.\nWatch out, these are very challenging!"
            hint = "There is 1 in every course and secret stage (except The Secret Aquarium and Tower Of The Wing Cap). There are none in the castle."
            listStr = "moonlist"
        end
        djui_chat_message_create("\\#ffff50\\There are "..strawbNumber.." "..strawbName.." hidden throughout the game!")
        djui_chat_message_create("\\#ffff50\\"..rules)
        djui_chat_message_create("\\#ffff50\\"..hint)
        djui_chat_message_create("\\#ffff50\\Type \\#50ff50\\/sb_info "..listStr.."\\#ffff50\\ for a list of all "..strawbName..".")
    end
    return true
end
if strawberriesExist then
    --[[hook_chat_command("sb_info", "[LIST] - Get info about strawberries", strawberry_hint_command)
    if gGlobalSyncTable.goldBerryDone then
        --update_chat_command_description("sb_info", "[LIST|GOLD|GOLDLIST|MOON|MOONLIST] - Get info about strawberries")
    elseif gGlobalSyncTable.redBerryDone then
        --update_chat_command_description("sb_info", "[LIST|GOLD|GOLDLIST] - Get info about strawberries")
    end]]

    hook_chat_command("sb_info", "- Get info about strawberries", function()
        strawbMenuOpen = true
        return true
    end)
end